//#version 3.7;

//------------------------------------------
// 
// POV-Ray Scene description language written by
// Bill Walker - 2016
//------------------------------------------

//global_settings { assumed_gamma 1.0 }

//#include "math.inc"

// mod (A, B)

// Let's assume a loop of N from 0 to 1, step 0.2
// we want to do mod (N, Step)
// but both numbers need to be multiplied by some power of ten to BOTH be integers

// need to use the MAX power of either result








//#declare N = 0;
//#debug concat("N = ", str(N, 0, 0), " abs(N) = ", str(abs(N), 0, 8), "\n")
//#debug concat("Sign N = ", str(sgn(N), 0, 0), "\n")
//#declare Test = mod(N, -1);

#macro I (_A, _B, _Q)
    // Check if N < 0
    // Check if N = 0
    // Check if > 1 or < 1
    // #if (N > 1)
    // Check when > 1 if there is a remainder after int()
    // #if (int(N) = N)
    
    #local Arg = array [2] {_A, _B};
    #local Power = 0;

    #for (Test, 0, 1)
        #local _Digits = strlen (str (Arg [Test], 0, _Q))-2;
        #debug concat("Arg [", str(Test, 0, 0), "] to ", str(_Digits, 0, 0), " digits: ", str(Arg [Test], 0, _Digits), "\n")
        
        #for (C, 0, _Digits)
            #local _M = Arg [Test] * pow (10, C);
            //#debug concat("_M: ", str(_M, 0, _Digits), "      int(_M): ", str(int(_M), 0, _Digits), "\n")
            #if (int (_M) = _M)
                #break
            #end
        #end
        #local Power = max(Power, C);
    #end // end for Test
    
    Power
    
#end

/*
#declare AA = 1;
#declare BB = 0.08;

#declare Pow10 = I (AA, BB, 11);
#debug concat("Raise both arguments to pow (10, ", str(Pow10, 0, 0), ") to use mod (", str(AA*pow(10, Pow10), 0, 0), ", ", str(BB*pow(10, Pow10), 0, 0), ") \n")
#declare Raw = mod (AA, BB);
#declare Mod = mod (AA*pow(10, Pow10), BB*pow(10, Pow10));
#declare ModDiv = Mod / pow (10, Pow10);
#debug concat("Raw: ", str(Raw, 0, 5), ",     both Multiplied: ", str(Mod, 0, 5), "...      then result Divided: ", str(ModDiv, 0, 5), " \n")

#error "end"

*/